<!--
    Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)
    
    SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { handleModeEnum } from '@/enums/enums';
import { request } from '@/lib/request';
import { useDashboardStore } from '@/stores/dashboard';
import type { dashboardItem } from '@/types/dashboard';
import { storeToRefs } from 'pinia';
import { computed, inject, ref } from 'vue';
import { useI18n } from 'vue-i18n';
import FavoriteStar from '@/components/general/FavoriteStar.vue';
import Checkbox from '../general/form/Checkbox.vue';
import PaneTypeBadge from '@/components/account/PaneTypeBadge.vue';
import Dropdown from '@/components/general/Dropdown.vue';
import Button from '@/components/general/Button.vue';
import { useAccountStore } from '@/stores/account';
import { useBaseStore } from '@/stores/base';


const { t } = useI18n();
const $t = t;
const store = useDashboardStore();
const accountStore = useAccountStore();
const baseStore = useBaseStore();
const { message } = storeToRefs(baseStore);
const { paneHandleMode, paneId, folderParent, isMoveToFolderModalOpen, favorites, select, selectedItems } = storeToRefs(store);
const { mail } = storeToRefs(accountStore);

let configuration = inject<any>('configuration');
const apiServer = configuration.apiServer;
const basePath = configuration.basePath;

const dropdown = ref(null);

const props = defineProps<{
    item: dashboardItem
}>();

const emits = defineEmits<{
    (e: 'favorite'): void,
}>();

const getStyleOfGridItem = (item: dashboardItem) => {
    let style: { [k: string]: any } = { backgroundColor: item.background_color };
    if (item.background_image !== null)
        style.backgroundImage = `url(${apiServer + item.background_image})`
    return style;
}

const showDeleteModal = (value: boolean, close: ()=>void, hashcode?: string, ) => {
    close();
    if (!value)
        paneId.value = '';
    else if (hashcode) {
        paneId.value = hashcode;
    }
    paneHandleMode.value = handleModeEnum.DELETE;
}

const moveToFolder = (hashcode: string, folder: string, close: ()=>void) => {
    close();
    isMoveToFolderModalOpen.value = true;
    //paneId.value = hashcode;
    selectedItems.value.push(hashcode);
    folderParent.value = folder;
}

const getLastUpdate = (date: string) => {
    return new Date(date.replace(' ', 'T').split('.')[0]).toLocaleDateString('de-DE', { year: 'numeric', month: 'long', day: 'numeric' });
}

const removeFromFavorites = async () => {
    const response = await request('DELETE', configuration.apiServer + `/api/overview/favorite/${props.item.hash_pane}`, undefined, 'application/json', false, true);
    if (response && response.success) {
        favorites.value = response.favorites;
        message.value = $t('dashboardPage.favorites.delete.message');
        select.value = false;
        emits('favorite');
    } else {
        console.error("Couldn't be deleted to favorites");
    }
}

const addToFavorites = async () => {
    const response = await request('POST', configuration.apiServer + `/api/overview/favorite/${props.item.hash_pane}`, undefined, 'application/json', false, true);
    if (response && response.success) {
        favorites.value = response.favorites;
        message.value = $t('dashboardPage.favorites.add.message');
        select.value = false;
        emits('favorite');
    } else {
        console.error("Couldn't be added to favorites");
    }
}

const setPaneElementSelection = (close: ()=>void) => {
    close();
    select.value = true;
}

const selection = computed({
    get: () => {
        return selectedItems.value.findIndex((item) => item === props.item.hash_pane) !== -1;
    },
    set: (value: boolean) => {
        if (value)
            selectedItems.value.push(props.item.hash_pane);
        else {
            const itemIndex = selectedItems.value.findIndex((item) => item === props.item.hash_pane);
            const localSelectedItems = JSON.parse(JSON.stringify(selectedItems.value));
            localSelectedItems.splice(itemIndex, 1)
            selectedItems.value = localSelectedItems;
        }

    }
});

</script>
<template>
    <div class="inline-block max-w-full relative align-middle rounded-2xl shadow-md h-[300px] w-full bg-cover" :style="getStyleOfGridItem(item)">
        <div class="size-5 ml-3 mt-3"
            v-if="item.origin_mail !== undefined && item.origin_mail !== null"
            @click="removeFromFavorites">
            <FavoriteStar :isFavorite="true" />
        </div>
        <div class="size-5 ml-3 mt-3" v-else @click="addToFavorites">
            <FavoriteStar :isFavorite="false" />
        </div>
        <div class="bg-white/80 p-8 bottom-0 left-0 right-0 box-border absolute rounded-2xl">
            <div class="flex flex-row-reverse">
                <PaneTypeBadge :type="item.type"/>
            </div>
            <h4 class="text-xl text-elipsis line-clamp-2">{{ item.headline }}</h4>
            <b class="text-gray-400 font-thin text-elipsis line-clamp-2">{{ item.subheadline }}</b>
            <p class="text-gray-400 font-thin text-elipsis line-clamp-2 mt-4">{{ $t("dashboardPage.filterBy.date.lastVisited") }}:
                <span>{{ getLastUpdate(item.last_update) }}</span><br>
                <i
                    v-if="(item.origin_mail === undefined) || (item.origin_mail !== undefined && item.origin_mail !== item.mail)">{{ item.origin_mail }}</i>
            </p>
            <div class="mt-8 flex flex-row justify-between" v-if="!select">
                <Dropdown placement="top-start" rounded="rounded-full" v-if="(item.origin_mail === undefined || item.origin_mail === null) || (item.origin_mail !== undefined && item.origin_mail === item.mail)">
                    <template #button>
                        <Tooltip :tooltip="$t('tooltips.advancedSettings')">
                            <button class="size-8 rounded-full text-gray-500 bg-white hover:bg-gray-100 leading-8 text-[24px] align-middle text-center px-1 focus:rounded-full">
                                <i class="ri-more-line ri-1x"></i>
                            </button>
                        </Tooltip>
                    </template>
                    <template v-slot="{close}">
                        <div class="cursor-pointer hover:bg-gray-100 p-1 rounded flex flex-row gap-2 leading-4 align-middle" @click="moveToFolder(item.hash_pane, item.folder, close)">
                            <div class="text-[16px] text-blue-800"><i class="ri-folder-2-line"></i></div>{{ $t("dashboardPage.folder.move.label") }}</div>
                        <div class="cursor-pointer hover:bg-gray-100 p-1 rounded flex flex-row gap-2 leading-4 align-middle" @click="setPaneElementSelection(close)"
                            v-if="(!item.origin_mail || item.origin_mail === mail)"><div class="text-[16px]"><i class="ri-check-line"></i></div><span>{{ $t("contentPage.markLabel") }}</span></div>
                        <div class="cursor-pointer hover:bg-gray-100 p-1 rounded flex flex-row gap-2 leading-4 align-middle" @click="showDeleteModal(true, close, item.hash_pane)">
                            <div class="text-[16px] text-red-700"><i class="ri-delete-bin-line"></i></div>{{ $t("contentPage.deleteLabel") }}
                        </div>
                    </template>
                </Dropdown>
                <div class="w-fit">
                    <Button variant="accent2" :to="basePath + 'a/' + item.hash_pane">{{ $t("dashboardPage.buttonPane") }}</Button>
                </div>
            </div>
            <div class="mt-4" v-else>
                <div>
                <Checkbox label="" v-model="selection" />
            </div>
        </div>
    </div>
</div></template>